unit ZusatzProcs;

INTERFACE

uses SysUtils, Windows, Classes, Consts;

FUNCTION ExecuteFile(const FileName, Params, DefaultDir: string;ShowCmd: Integer): THandle;
FUNCTION Worte(S : STRING) : CARDINAL;
FUNCTION WortN(S : ShortSTRING;n : BYTE) : STRING;
FUNCTION WTag (Datum : TDateTime) : ShortSTRING;
FUNCTION IstInteger(S : String) : BOOLEAN;
FUNCTION ZuhausePfad : ShortSTRING;

IMPLEMENTATION

uses Forms, ShellAPI;


function ExecuteFile(const FileName, Params, DefaultDir: string;
  ShowCmd: Integer): THandle;
var
  zFileName, zParams, zDir: array[0..79] of Char;
begin
  Result := ShellExecute(Application.MainForm.Handle, nil,
    StrPCopy(zFileName, FileName), StrPCopy(zParams, Params),
    StrPCopy(zDir, DefaultDir), ShowCmd);
end;


  FUNCTION Worte(S : STRING) : CARDINAL;
    {Gibt die Anzahl der Wrter in einem String zurck}
    VAR n,i : CARDINAL;
    BEGIN
      n:=0;
      i:=1;
      WHILE (i <= Length(S)) DO BEGIN
        {bis zum ersten bzw. nchsten Wort}
        WHILE (S[i] = #32) AND (i <= Length(S)) DO INC(i);
        IF (S[i]<>#32) AND (i <= Length(S)) THEN BEGIN
          {ein Wort abarbeiten}
          WHILE (S[i] <> #32) AND (i <= Length(S)) DO Inc(i);
          INC(n);
        END;
      END;
      Worte:=n;
    END;


  FUNCTION WortN(S : ShortSTRING;n : BYTE) : STRING;
    VAR i,n2   : BYTE;
        TmpStr : STRING;
    BEGIN
      n2:=0;
      i:=1;
      {wenn n=n2 dann aufhhren}
      WHILE (i <= BYTE(S[0])) AND (n <> N2) DO BEGIN
        TmpStr:='';
        {bis zum ersten bzw. nchsten Wort}
        WHILE (S[i] = #32) AND (i <= BYTE(S[0])) DO INC(i);
        IF (S[i]<>#32) AND (i <= BYTE(S[0])) THEN BEGIN
          {ein Wort abarbeiten}
          WHILE (S[i] <> #32) AND (i <= BYTE(S[0])) DO BEGIN
            TmpStr:=TmpStr+S[i];
            Inc(i);
          END;
          INC(n2);
        END;
      END;
      IF n=N2 THEN WortN:=TmpStr ELSE WortN:='';
    END;
           
FUNCTION WTag (Datum : TDateTime) : ShortSTRING;
  BEGIN
    CASE DayOfWeek(Datum) OF
      1 : Wtag := 'So';
      2 : Wtag := 'Mo';
      3 : Wtag := 'Di';
      4 : Wtag := 'Mi';
      5 : Wtag := 'Do';
      6 : Wtag := 'Fr';
      7 : Wtag := 'Sa';
    END;
  END;


FUNCTION IstInteger(S : String) : BOOLEAN;
  VAR I, Code : INTEGER;
  BEGIN
    Val(S, I, Code);
    {Fehler bei der Konvertierung in Integer?}
    IstInteger:=code = 0;
  END;

FUNCTION ZuhausePfad : ShortSTRING;
    {AUS: DOS International 8/91 Seite 258}
    {In jedem Fall ohne \ am Ende; auch wenn Root-Direktory}
    VAR ParamDir : STRING;
        i        : INTEGER;
    BEGIN
      ParamDir:=ParamStr(0);
      i:=Pos('.',ParamDir);
      WHILE ParamDir[i] <> '\' DO DEC(i);
      ZuhausePfad:=COPY(ParamDir,0,i-1);
    END;


end.
